<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode==='show'" ref="dialogForm" label-width="100px" label-position="right">
			<el-form-item label="设备SN" prop="device_sn">
				<el-input v-model="form.device_sn" placeholder="请输入设备SN" clearable></el-input>
			</el-form-item>
			<el-form-item label="设备分组" prop="group_id">
				<el-select v-model="form.group_id">
					<el-option v-for="(item,index) in groups" :key="index" :value="item.group_id" :label="item.group_name"></el-option>
				</el-select>
			</el-form-item>
			<el-form-item label="所属应用" prop="app_id">
				<el-select v-model="form.app_id">
					<el-option v-for="(item,index) in apps" :key="index" :value="item.app_id" :label="item.app_name"></el-option>
				</el-select>
			</el-form-item>
			<el-form-item label="启用状态" prop="status">
				<el-switch v-model="form.status" :active-value="1" :inactive-value="0"></el-switch>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!=='show'" type="primary" :loading="isSaveing" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '新增',
				edit: '编辑',
				show: '查看'
			},
			visible: false,
			isSaveing: false,
			//表单数据
			form: {
				device_id: null,
				device_sn: "",
				app_id: null,
				group_id: null,
				status: 1
			},
			//验证规则
			rules: {
				device_sn: [
					{required: true, message: '请输入设备SN'}
				],
				group_id: [
					{required: true, message: '请选择厂商'}
				],
				app_id: [
					{required: true, message: '请选择应用'}
				],
				status: [
					{required: true, message: '请选择状态'}
				]
			},
			groups: [],
			apps: []
		}
	},
	mounted() {
		this.loadGroups()
		this.loadApps()
	},
	methods: {
		async loadGroups() {
			const res = await this.$API.machine.group.option({});
			this.groups = res.data
		},
		async loadApps() {
			const res = await this.$API.system.app.option({});
			this.apps = res.data
		},
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},
		//表单提交方法
		async submit(){
			// 校验登录
			const validate = await this.$refs.dialogForm.validate().catch(() => {});
			if(!validate){ return false }
			this.isSaveing = true;
			const res = this.form.device_id ? await this.$API.machine.device.edit(this.form) : await this.$API.machine.device.add(this.form);
			this.isSaveing = false;
			this.$emit('success', this.form, this.mode)
			this.visible = false;
			this.$message.success(res.msg)
		},
		//表单注入数据
		setData(data){
			Object.assign(this.form, data)
		}
	}
}
</script>

<style>
</style>
